#!BPY

"""
Name: 'Material Replacer'
Blender: 244
Group: 'Materials'
"""

import Blender
from Blender.BGL import *
from Blender.Draw import *

# overenie, ci su materialy zamenene
def isReplaced():
	global matReplaced
	return len(matReplaced) > 0

# zamena materialov za zastupny material
def matReplace():
	global replMat, matReplaced
	# ziskaj material
	matRep = Blender.Material.Get(replMat.val)
	if matRep is not None:
		# nahrada materialov v meshiach
		for mesh in Blender.Mesh.Get():
			orgMat = [mesh.name, 'M', []]
			newMat = []
			for mat in mesh.materials:
				orgMat[2].append(mat.name)
				newMat.append(matRep)
			matReplaced.append(orgMat)
			mesh.materials = newMat
			mesh.update()
		# nahrada materialov v objektoch
		for obj in Blender.Object.Get():
			orgMat = [obj.name, 'O', []]
			newMat = []
			for mat in obj.getMaterials():
				orgMat[2].append(mat.name)
				newMat.append(matRep)
			matReplaced.append(orgMat)
			obj.setMaterials(newMat)

# vratenie povodnych materialov
def matRestore():
	global matReplaced
	# prejdi vsetky zaznamenane objekty
	for obj in matReplaced:
		mats = []
		for matName in obj[2]:
			mats.append(Blender.Material.Get(matName))
		# nahradenie objektov
		if obj[1] == 'O':
			bObj = Blender.Object.Get(obj[0])
			bObj.setMaterials(mats)
		if obj[1] == 'M':
			mesh = Blender.Mesh.Get(obj[0])
			mesh.materials = mats
			mesh.update()
	matReplaced = []


# vykreslenie ovladacich prvkov
def draw ():
  # vykresli GUI
  glClearColor(0.6, 0.6, 0.6, 1.0)
  glClear(GL_COLOR_BUFFER_BIT)
  global replMat
  replMat = String('Mat:',11,10,28,144,16,replMat.val,32,'Name of replacement material')
  if isReplaced():
    Button("Restore materials",10,10,10,144,16)
  else:
    Button("Replace materials",10,10,10,144,16)

# spracovanie udalosti klavesov a mysi
def event (ev, val):
  # ukoncenie skriptu
  if ev == ESCKEY: Exit()

# spracovanie udalosti tlacidiel
def proc (ev):
  # vymena materialov
  if ev == 10:
    if isReplaced(): matRestore()
    else: matReplace()
    Blender.Window.RedrawAll()


# main program
if __name__ == "__main__":

  # ovladacie prvky a zoznam materialov
  global replMat, matReplaced
  replMat = Create('')
  matReplaced = []
  # registruj spracovanie udalosti
  Register(draw, event, proc)
  # vykreslenie pouzivatelskeho interfejsu
  Blender.Redraw()
